/*
      1 Ԥ⥸塼

  (1) set_line_basic ƤǴŪԤ

  (2) analyze_1line ( 1 ԤϤ )  򷫤֤Ƥ

*/


#include <stdio.h>
#include <string.h>

#include "t2ps.h"

#define ROMAN  1
#define KANJI  2

static int tab_width,max_column;
static int mode = ROMAN;

/*------------- ȰԤĹꤹ --------------*/

set_line_basic(tab_width_,max_column_)
int tab_width_,max_column_;
{
	tab_width = tab_width_;
	max_column = max_column_;
}


/*-------------  Ԥ ----------------*/

int analyze_1line(line,  mbuf)
/*
      line        Ԥʸ
      mbuf[][]    ԤǼޤ꤭ʤä
                      ʬ䤹롣
                       8 ʿɽץ
                      ʤɤ롣
*/
char line[],mbuf[][MAX_COLUMN];
{
	int i,j,k,l,len,iline,high,low;
	char line2[MAX_LINEBUF2];
	unsigned char cha,cha2;

	len = strlen(line);

       /* tab ִ */

	j = 0;
	for(i=0;i<len;i++){
		if ( line[i] != '\t' ){
			line2[j] = line[i];
			j++;
		} else {
			l = tab_width - ( j % tab_width );
			for(k=0;k<l;k++){
				line2[j] = ' ';
				j++;
			}
		}
	}
	line2[j] = '\0';

	if ( j >= MAX_LINEBUF2 ) {
		fprintf(stderr,"MAX_LINEBUF2 is too small. Stop.\n");
		exit(1);
	}

       /* Ԥ */

	i = 0;  /* line2[i] Υݥ */
	j = 0;  /* mbuf[][j] Υݥ */
	k = 0;  /* ߽ƤԤβʸܤ */
	iline = 0; /* ܤ */
	mode = ROMAN;  /* show ¹Ԥ ROMAN ˤʤäƤޤ */

	len = strlen(line2);

     /*  1 ʸ 80 ǡ80,81 ʸܤ
         ξ硢뤳ȤˤƤ
     */

	while(1){

		if ( i >= len ) {
			mbuf[iline][j] = '\0';
			break;
		}
		if ( k >= max_column ) {
			if ( j >= MAX_COLUMN ) {
				fprintf(stderr,"MAX_COLUMN is too small. Stop\n");
				exit(1);
			}
			mbuf[iline][j] = '\0';
			iline++;
			if ( iline >= MAX_ROW ) {
				fprintf(stderr,"MAX_ROW is too small. Stop.\n");
				exit(1);
			}
			j = 0;
			k = 0;
			mode = ROMAN;/* show ¹Ԥ ROMAN ˤʤäƤޤ */
		}
			
		cha = line2[i];
		i++;k++;
		if ( cha <= 127 ) {  /* ޻ν */
			if ( mode == KANJI ){
				mode = ROMAN;
				mbuf[iline][j  ] = '\\';
				mbuf[iline][j+1] = '3';
				mbuf[iline][j+2] = '7';
				mbuf[iline][j+3] = '7';
				mbuf[iline][j+4] = '\\';
				mbuf[iline][j+5] = '0';
				mbuf[iline][j+6] = '0';
				mbuf[iline][j+7] = '0';
				j = j + 8;
			}
			if ( cha == '\\' || cha == '(' || 
				 cha == ')'  || cha == '%' ) {
				mbuf[iline][j] = '\\';
				mbuf[iline][j+1] = cha;
				j = j + 2;
			} else {
				mbuf[iline][j] = cha;
				j++;
			}
		} else {     /* ν */
			cha2 = line2[i];
			i++;k++;
			if ( mode == ROMAN ){
				mode = KANJI;
				mbuf[iline][j  ] = '\\';
				mbuf[iline][j+1] = '3';
				mbuf[iline][j+2] = '7';
				mbuf[iline][j+3] = '7';
				mbuf[iline][j+4] = '\\';
				mbuf[iline][j+5] = '0';
				mbuf[iline][j+6] = '0';
				mbuf[iline][j+7] = '1';
				j = j + 8;
			}
			high = cha  & 0x7f;
			low  = cha2 & 0x7f;

			write_oct(&mbuf[iline][j],high);
			write_oct(&mbuf[iline][j+4],low);
			j = j + 8;
		}
	}
	return(iline+1);
}


/*--------- 8 ʿ񤭹 --------*/

write_oct(moji,value)
char moji[];
int value;
{
	int i1,i2,i3;

	i1 = value / 64;
	value = value - 64 * i1;
	i2 = value / 8;
	value = value - 8 * i2;
	i3 = value;

	moji[0] = '\\';
	moji[1] = '0'+i1;
	moji[2] = '0'+i2;
	moji[3] = '0'+i3;
}
